const reminderFoxBundle = document.getElementById("reminderFox-bundle");  
var reminderFox_snoozed = false;

function loadAlarm() {
		var recentReminder = window.arguments[0].alarmreminder;
		var snoozeTime = window.arguments[0].snoozeTime;		
		var listName = window.arguments[0].todoListName;

		var timeString = reminderFox_getTimeString(recentReminder);
		if ( timeString == null ) {
			timeString =  reminderFox_getBundle().getString("rf.add.time.allday");
		}
		recentReminder  = reminderFox_processReminderDescription(recentReminder, new Date().getFullYear());	

		var reminderString =  recentReminder.summary;
		
		var dateVariableString;
		try {
			dateVariableString = reminderFox_prefs.getCharPref(REMINDER_FOX_PREF + "." + REMINDER_FOX_LIST_DATE_LABEL);
		} catch(e) {
		}			
		var dateString =reminderFox_getDateVariable( null, recentReminder.date, dateVariableString );		
		
		if ( snoozeTime != null && snoozeTime != "" ) {
			var snoozeTimeList = document.getElementById("reminderFox-snoozeTime");	
			snoozeTimeList.label = snoozeTime;
		}
		
		if ( listName != null && listName.length > 0 && listName != "null" ) {
			document.title = 	document.title + " [" + listName  + "]";
		}
		
		// if this is a past reminder, indicate that in the title
		if (  window.arguments[0].alarmMissed == "true" ) {
			document.title = 	document.title + " (" + reminderFox_getBundle().getString( "rf.alarm.missedalarm.title" )  + ")";
		}
		
		document.getElementById("reminderDateText").setAttribute("value", dateString);
		document.getElementById("reminderTimeText").setAttribute("value", timeString);
		document.getElementById("reminderDescriptionText").setAttribute("value", reminderString);				
		if ( recentReminder.priority == REMINDER_PRIORITY_IMPORTANT) { 
			document.getElementById("reminderDescriptionText").setAttribute("style", "color: red;");
		}
		
		if ( recentReminder.notes != null ) { 
			document.getElementById("notesText").setAttribute("value", recentReminder.notes);		
			document.getElementById("notesText").removeAttribute( "hidden");
		}
		
		playAlarmSound();

}

function playAlarmSound() {
	// play a sound for notification (if the user elects to)
	try {
		var playSound = true;
		try {
			playSound = reminderFox_prefs.getBoolPref(REMINDER_FOX_PREF + "." +  REMINDER_FOX_ALARM_SOUND);
		}
		catch ( e) {
		}
		if ( playSound ) {
			reminderFox_playSound();
	  	} // end if		
	}
	catch ( e ) {
	}
}

function reminderFox_editReminderFromAlarm() {
	var reminderID = window.arguments[0].currentAlarmId;
	if ( reminderID != null ) {
		reminderFox_openAddRemindersDialog2(reminderID);
	}
}

function reminderFox_openAddRemindersDialog2(reminderID) {
   var windowManager = Components.classes['@mozilla.org/appshell/window-mediator;1'].getService();
   var windowManagerInterface = windowManager.QueryInterface(Components.interfaces.nsIWindowMediator);
   var topWindow = windowManagerInterface.getMostRecentWindow("window:reminderFoxEdit");
 	var isReminder = window.arguments[0].isReminderType;
 
 	
   if (topWindow) {
    	 topWindow.focus();
    	if ( isReminder == "true" ) {	 
			topWindow.	selectReminderById(reminderID	);
			topWindow.editReminder();
    	}
    	else { 
			var i;
			var reminderFoxTodosArrayArg =  reminderFox_getReminderTodos();
			for ( var n in reminderFoxTodosArrayArg ) {
				var reminderTodos = reminderFoxTodosArrayArg[n];
				for (  i = 0; i < reminderTodos.length; i++ ) {		
					if ( reminderTodos[i].id == reminderID ) {
						topWindow.	selectTodoById(n, reminderID	);
						topWindow.editTodo();
						break;
						
					}
				}
			}
		}    		
   }
   else {
   		var newOptions;
   	    if ( isReminder == "true" ) {	 
   			newOptions = { callback: window.arguments[0].synccallback, editID: reminderID, isAReminder: isReminder, todoList: null };   			
			var dlg = window.openDialog("chrome://reminderfox/content/addreminder-dialog.xul",
							"addreminder-dialog", "chrome,centerscreen,resizable", "reminders", newOptions);   			

   	    }
   	    else {
			var reminderFoxTodosArrayArg =  reminderFox_getReminderTodos();
			for ( var n in reminderFoxTodosArrayArg ) {
				var reminderTodos = reminderFoxTodosArrayArg[n];
				for (  i = 0; i < reminderTodos.length; i++ ) {		
					if ( reminderTodos[i].id == reminderID ) {
				  	    	newOptions = { callback: window.arguments[0].synccallback, editID: reminderID, isAReminder: isReminder, todoList: n };
							var dlg = window.openDialog("chrome://reminderfox/content/addreminder-dialog.xul",
								"addreminder-dialog", "chrome,centerscreen,resizable", "reminders", newOptions);
						
					}
				}
			}   	    	
 
   	    }
	}
}

function reminderFox_alarmDone() {
	var myAlarmId = window.arguments[0].currentAlarmId;
	 var isReminder = window.arguments[0].isReminderType;
	var reminder;
	
	// need to clear my reminders/todos from memory (as they may have changed in edit window)
	// and refresh them	
	reminderFox_clearRemindersAndTodos();
	if ( isReminder == "true"  ) {
		reminder =	reminderFox_getRemindersById( myAlarmId);
	}
	else {
		reminder =	reminderFox_getSpecificTodoById( myAlarmId);
	}

	
	// mark reminder's last-acknowleged  (unless snooze was pressed)
	if ( reminder != null && !reminderFox_snoozed ) {
		reminder.alarmLastAcknowledge = new Date().getTime();
		reminderFox_lastModifiedTime = reminderFox_prefs.getCharPref(REMINDER_FOX_PREF + "." + REMINDER_FOX_LAST_MODIFIED) + "";
		reminderFox_writeOutRemindersAndTodos(true);		 
		
		// could call background sync here ..

		var windowEnumerator =  reminderFox_getWindowEnumerator();
		if (windowEnumerator.hasMoreElements()) {			
			var oldestWindow = windowEnumerator.getNext();
			for ( var i = 0; i < oldestWindow.reminderFox_alarmList.length; i++ ) {
				var currentAlarmId =  oldestWindow.reminderFox_alarmList[i].alarmId;
				if ( currentAlarmId == myAlarmId ) { 
					reminderFox_removeElement( oldestWindow.reminderFox_alarmList, i);
				}
			}
		}
		
		// if the edit window is open and we Acknowledge this alarm, we need to set the lastAck  for this reminder instnace 
		// in the editWindow as well, or it will still have the old value and overwrite the correct one when the edit 
		// window is closed...
	   var windowManager = Components.classes['@mozilla.org/appshell/window-mediator;1'].getService();
	   var windowManagerInterface = windowManager.QueryInterface(Components.interfaces.nsIWindowMediator);
	   var topWindow = windowManagerInterface.getMostRecentWindow("window:reminderFoxEdit");	 
	   if (topWindow) {
	   		var editWindowReminder =	topWindow.reminderFox_getRemindersById( myAlarmId );
	   		if ( editWindowReminder != null ) {
	   			editWindowReminder.alarmLastAcknowledge = reminder.alarmLastAcknowledge;
	   		}
	   }										
	}
	
	window.close();
}

function reminderFox_alarmChooseDone() {
	if ( 	document.getElementById("snoozeButton").getAttribute( "default" ) == true ||
		document.getElementById("snoozeButton").getAttribute( "default" ) == "true"	) {
		reminderFox_snooze();
	}
	else {
		reminderFox_alarmDone();
	}
}

function reminderFox_snoozeTimeChanged() {
	document.getElementById("snoozeButton").setAttribute( "default", true );
	document.getElementById("okButton").setAttribute( "default", false );
}

function reminderFox_snooze() {
		reminderFox_snoozed = true;
		var currentAlarmId = window.arguments[0].currentAlarmId;
		var recentReminder = window.arguments[0].alarmreminder;
		var isReminder = window.arguments[0].isReminderType;
		var listName = window.arguments[0].todoListName;		
		
		var snoozeTimeList = document.getElementById("reminderFox-snoozeTime");	
		var snoozeTime = snoozeTimeList.label;
		if ( reminderFox_isInteger( snoozeTime ) ) {
			var currentTime = new Date().getTime();
			var alarmTime = currentTime + (snoozeTime*60000);		
					
			var windowEnumerator =  reminderFox_getWindowEnumerator();
			if (windowEnumerator.hasMoreElements()) {
				var oldestWindow = windowEnumerator.getNext();
				
				// update existing entry from alarm list with snooze set and updated alarmTime
				for ( var i = 0; i < oldestWindow.reminderFox_alarmList.length; i++ ) {
					var myAlarmId =  oldestWindow.reminderFox_alarmList[i].alarmId;
					if ( currentAlarmId == myAlarmId ) { 
						oldestWindow.reminderFox_alarmList[i].snoozed = true;
						oldestWindow.reminderFox_alarmList[i].timeOfAlarm = alarmTime;
					}
				}
				if ( listName == null ){
					listName = "";
				}				
				oldestWindow.setTimeout('reminderFox_showAlarm("'+recentReminder.date.getTime()+'","'+currentAlarmId +'","'+isReminder +'","'+alarmTime +'","'+listName + '","'+false+ '","'+snoozeTime+'")', snoozeTime*60000);			
			}		
		}
	window.close();
}


